c	base11.f
C
C       MULTISCALE MIXED FINITE ELEMENT BASIS
C       TYPE = ONE  NODE = ONE OVER-SAMPLING 
C       TO SOLVE THE MATRIX PROBLEM, USE dmgd9v
C
C***************************************************
c      program main
	subroutine base11(ppp,mi,mj)
      parameter (max_nm=1402193, ! nm for level 9
     +           max_nxf=1025,  ! nxf for level 9
     +           max_nyf=1025)  ! nyf for level 9
c     +           max_nx=128, max_ny=128)
	include 'parameter.dat'
	parameter(max_nxyf=(max_nx+1)*(max_ny+1))
      real*8   ppp(max_nxyf)

      real*8 ma(max_nm*9),mrhs(max_nm),a(max_nxf,max_nyf,9),
     +       vb(max_nm),ldu(3*max_nm),work(max_nxf*12),
     +       wa(max_nm),wb(max_nm),p(max_nm), 
     +       perm(-255:1280,-255:1280), 
     +       erroru(2,max_nxf,max_nyf),rhs(max_nxf,max_nyf)

      real*8 hx,hy,tol,resno,area,x,y,eu,eflux,value
      real*8 stf1(3,3),stf2(3,3),stf3(3,3),stf4(3,3),stf5(3,3),stf6(3,3)
      real*8 xmax,ymax,x0,y0,xbloack,yblock
      real*8 coor,basis,exact11
      integer ielement
      integer nx,ny,nxc,nyc,nxf,nyf,nm,levels,i,j,k,l,
     +        istart,iprep,maxit,ifail,index,kcoor,node,
     +        iout(6),n1,n2,n3,iteration,num,it,nxyf,mx,
     +        levelsglobal,ineps,mi,mj,mimax,mjmax,nx0,ny0,
     +        nperm1,nperm2,nperm3,ntran
	real*8 eps
	common /epsilon/eps
      common /domain/ xmax,ymax
      common /param/ nxL,nyL,hx,hy
	common /perm/perm
      data nxc,nyc,istart,iprep,maxit,tol,ifail
     +    /5,5,0,0,100,1.0d-8,110/
      data iout/0,0,0,0,0,0/

C.....PARAMETERS..............................

      open(1,file='input.dat',status='old')
      read(1,*) levels,nx,mx,levelsglobal,ineps,mimax,mjmax
	read(1,*)
	read(1,*) xleft,yleft,xright,yright

      close(1)

	eps=1.d0/ineps
      ny=nx
	nxL=nx
	nyL=ny
      my=mx
      xmax=(xright-xleft)/mx
      ymax=(yright-yleft)/my
c      hx=1.0d0/(nx*mx)
c      hy=1.0d0/(nx*mx)
      area=0.5d0*hx*hy      ! area of the element

      ! Over-sampling parameters
      kx=nx
      ky=ny
      nx=4*nx
      ny=4*ny
      xblock=xmax
      yblock=ymax
      xmax=4.0d0*xmax
      ymax=4.0d0*ymax
      levels=levels+2

C.....MULTIGRID INFORMATION...................

      nxf=nxc
      nyf=nyc
      nm=nxf*nyf
      do 10 k=2,levels
        nxf=2*nxf-1
        nyf=2*nyf-1
        nm=nm+nxf*nyf
   10 continue

c      print*, 'nxf=',nxf,'nyf=',nyf,'nm=',nm
c      print*, 'xmax=',xmax,'hx=',hx
 
C***********************************************************
c      do 3000 mj=1,mjmax
c      do 3000 mi=1,mimax
C***********************************************************
      
      x0=(mi-1)*xblock-2.0d0*xblock ! (x0,y0) is the left-bottom
      y0=(mj-1)*yblock-yblock       ! corner of the sample
      nx0=(mi-1)*kx-2*kx+1          
      ny0=(mj-1)*ky-ky+1             
c      print*, 'mi,mj,nx0,ny0,x0,y0=',mi,mj,nx0,ny0,x0,y0

c     do i=nx0,nx0+nx-1
c        do j=ny0,ny0+ny-1
c           perm(i,j)=(coef((i-1)*hx,(j-1)*hy)+coef((i-1)*hx,j*hy)
c    +                +coef(i*hx,(j-1)*hy)+coef(i*hx,j*hy))/4.0d0
c        end do
c     end do

      do j=1,nyf
         do i=1,nxf
            do k=1,9
               a(i,j,k)=0.0d0
            end do
         end do
      end do

      ! boundary nodes
      do j=1,ny+1 ! right boundary
         a(nx+1,j,5)=1.0d0
      end do

      do i=1,nx+1 ! bottom boundary
         a(i,1,5)=1.0d0
      end do

      do i=1,nx+1 
         do j=i,ny+1
            a(i,j,5)=1.0d0
         end do
      end do

      ! Interior nodes
      do j=2,ny-1
         do i=j+1,nx
              value=perm(ntran(nx0-1+i-1),ntran(ny0-1+j-1))
            call get_stiff(stf1,2,i-1,j-1,value)
              value=perm(ntran(nx0-1+i-1),ntran(ny0-1+j-1))
            call get_stiff(stf2,1,i-1,j-1,value)
              value=perm(ntran(nx0-1+i),ntran(ny0-1+j-1))
            call get_stiff(stf3,2,i,j-1,value)
              value=perm(ntran(nx0-1+i-1),ntran(ny0-1+j))
            call get_stiff(stf4,1,i-1,j,value)
              value=perm(ntran(nx0-1+i),ntran(ny0-1+j))
            call get_stiff(stf5,2,i,j,value)
              value=perm(ntran(nx0-1+i),ntran(ny0-1+j))
            call get_stiff(stf6,1,i,j,value)
            if(j.eq.2) then
               a(i,j,1)=0.0d0
               a(i,j,2)=0.0d0
            else
               a(i,j,1)=stf1(1,2)+stf2(1,3)
               a(i,j,2)=stf2(2,3)+stf3(1,3)
            end if
            if(i.eq.j+1) then
               a(i,j,4)=0.0d0
            else
               a(i,j,4)=stf1(2,3)+stf4(1,2)
            end if
            a(i,j,5)=stf1(2,2)+stf2(3,3)+stf3(3,3)
     +              +stf4(2,2)+stf5(1,1)+stf6(1,1)
            if(i.eq.nx) then
               a(i,j,6)=0.0d0
            else
               a(i,j,6)=stf3(2,3)+stf6(1,2)
            end if
            if(i.eq.j+1) then
               a(i,j,8)=0.0d0
            else
               a(i,j,8)=stf4(2,3)+stf5(1,3)
            end if
            if(i.eq.nx) then
               a(i,j,9)=0.0d0
            else
               a(i,j,9)=stf5(1,2)+stf6(1,3)
            end if
        end do
      end do

      ! change to the multigrid solver format
      do j=1,nyf  
         do i=1,nxf
            do k=1,9
               call assign_ma(ma,i,j,k,a(i,j,k),nxf,nyf)
            end do
         end do
      end do

C.....ASSEMBLE THE RHS...................................

      do j=1,nyf
         do i=1,nxf
            rhs(i,j)=0.0d0
         end do
      end do

      ! boundary nodes
      do j=1,ny+1 ! right
         rhs(nx+1,j)=exact11(x0+nx*hx,y0+(j-1)*hy,x0,y0)
      end do

      do i=1,nx+1 ! bottom
         rhs(i,1)=exact11(x0+(i-1)*hx,y0,x0,y0)
      end do

      do i=1,nx+1
         do j=i,ny+1
            rhs(i,j)=exact11(x0+(i-1)*hx,y0+(j-1)*hy,x0,y0)
         end do
      end do

      ! Interior nodes
      j=2 ! next to the bottom boundary
      do i=j+1,nx
              value=perm(ntran(nx0-1+i-1),ntran(ny0-1+j-1))
         call get_stiff(stf1,2,i-1,j-1,value)
              value=perm(ntran(nx0-1+i-1),ntran(ny0-1+j-1))
         call get_stiff(stf2,1,i-1,j-1,value)
              value=perm(ntran(nx0-1+i),ntran(ny0-1+j-1))
         call get_stiff(stf3,2,i,j-1,value)
         rhs(i,j)=rhs(i,j)
     +           -(stf1(1,2)+stf2(1,3))*rhs(i-1,j-1)
     +           -(stf2(2,3)+stf3(1,3))*rhs(i,j-1)
      end do
      do j=2,ny-1
         i=j+1 ! next to the diagonal 
              value=perm(ntran(nx0-1+i-1),ntran(ny0-1+j-1))
         call get_stiff(stf1,2,i-1,j-1,value)
              value=perm(ntran(nx0-1+i-1),ntran(ny0-1+j))
         call get_stiff(stf4,1,i-1,j,value)
              value=perm(ntran(nx0-1+i),ntran(ny0-1+j))
         call get_stiff(stf5,2,i,j,value)
         rhs(i,j)=rhs(i,j)
     +           -(stf1(2,3)+stf4(1,2))*rhs(i-1,j)
     +           -(stf4(2,3)+stf5(1,3))*rhs(i,j+1)
         i=nx  ! next to the right boundary
              value=perm(ntran(nx0-1+i),ntran(ny0-1+j-1))
         call get_stiff(stf3,2,i,j-1,value)
              value=perm(ntran(nx0-1+i),ntran(ny0-1+j))
         call get_stiff(stf5,2,i,j,value)
              value=perm(ntran(nx0-1+i),ntran(ny0-1+j))
         call get_stiff(stf6,1,i,j,value)
         rhs(i,j)=rhs(i,j)
     +           -(stf3(2,3)+stf6(1,2))*rhs(i+1,j)
     +           -(stf5(1,2)+stf6(1,3))*rhs(i+1,j+1)
      end do

      ! change to the multigrid solver format
      do j=1,nyf  
         do i=1,nxf
            call assign_mrhs(mrhs,i,j,rhs(i,j),nxf,nyf)
         end do
      end do

c      print*, 'go to mgd9v'
      call mgd9v(levels,nxc,nyc,nxf,nyf,nm,iout,istart,iprep,
     +     maxit,tol,mrhs,ma,p,vb,work,ldu,wa,wb,resno,ifail)
c      print*,' ifail: ',ifail,' resno: ',resno
c      print*, 'out of mgd9v'

 

      k=0
      do j=ky+1,2*ky+1
         do i=2*kx+1,3*kx+1
            k=k+1
            ppp(k)=p((j-1)*(nx+1)+i)
         end do
      end do

c      nxyf=(kx+1)*(ky+1)
 
c     open(1,file='base1.1',form='unformatted',status='unknown')
c      write(1,*) nxyf, (ppp(i),i=1,nxyf)

c 3000 continue
c      close(1)

      end
 


C     -------------------------------------------------
C     SUBROUTINE ASSIGN_MA
C     -------------------------------------------------
      subroutine assign_ma(ma,i,j,k,value,nxf,nyf)
      integer i,j,k,nxf,nyf
      real*8 ma(nxf,nyf,9),value

      ma(i,j,k)=value

      return
      end

C     -------------------------------------------------
C     SUBROUTINE ASSIGN_MRHS
C     -------------------------------------------------
      subroutine assign_mrhs(mrhs,i,j,value,nxf,nyf)
      integer i,j,nxf,nyf
      real*8 mrhs(nxf,nyf),value

      mrhs(i,j)=value

      return
      end
 

C     --------------------------------------------
C     FUNCTION COOR
C     --------------------------------------------
      real*8 function coor(index,node,kcoor,i,j,x0,y0)
      common /param/ nx,ny,hx,hy
      real*8 hx,hy,x0,y0
      integer nx,ny,index,node,kcoor,i,j

C     print*, 'this is coor'

      if (index.eq.2) go to 100
      
      if     (node.eq.1.and.kcoor.eq.1) then
        coor=x0+i*hx
      elseif (node.eq.1.and.kcoor.eq.2) then
        coor=y0+(j-1)*hy+0.5d0*hy
      elseif (node.eq.2.and.kcoor.eq.1) then
        coor=x0+(i-1)*hx+0.5d0*hx
      elseif (node.eq.2.and.kcoor.eq.2) then
        coor=y0+(j-1)*hy+0.5d0*hy
      elseif (node.eq.3.and.kcoor.eq.1) then
        coor=x0+(i-1)*hx+0.5d0*hx
      elseif (node.eq.3.and.kcoor.eq.2) then
        coor=y0+(j-1)*hy
      else
        print*, 'problem here in function coor!'
      endif
      go to 200

  100 continue 
      
      if     (node.eq.1.and.kcoor.eq.1) then
        coor=x0+(i-1)*hx+0.5d0*hx
      elseif (node.eq.1.and.kcoor.eq.2) then
        coor=y0+j*hy
      elseif (node.eq.2.and.kcoor.eq.1) then
        coor=x0+(i-1)*hx
      elseif (node.eq.2.and.kcoor.eq.2) then
        coor=y0+(j-1)*hy+0.5d0*hy
      elseif (node.eq.3.and.kcoor.eq.1) then
        coor=x0+(i-1)*hx+0.5d0*hx
      elseif (node.eq.3.and.kcoor.eq.2) then
        coor=y0+(j-1)*hy+0.5d0*hy
      else
        print*, 'problem here in function coor!'
      endif

  200 continue

      return
      end

C     ----------------------------------------------
C     FUNCTION BASIS
C     ----------------------------------------------
      real*8 function basis(index,node,x,y,i,j,x0,y0)
      common /param/ nx,ny,hx,hy
      real*8 hx,hy,x,y,x0,y0,x1,y1
      integer nx,ny,index,node,kcoor,i,j

      x1=x0+(i-1)*hx
      y1=y0+(j-1)*hy

      if (index.eq.2) go to 100

      if     (node.eq.1.) then
        basis=-(x-x1-hx)/hx
      elseif (node.eq.2) then
        basis=(x-x1)/hx-(y-y1)/hy
      elseif (node.eq.3) then
        basis=(y-y1)/hy
      else
        print*, 'problem here in function basis!'
      endif
      go to 200

  100 continue

      if     (node.eq.1.) then
        basis=-(y-y1-hy)/hy
      elseif (node.eq.2) then
        basis=(x-x1)/hx
      elseif (node.eq.3) then
        basis=(y-y1)/hy-(x-x1)/hx
      else
        print*, 'problem here in function basis!'
      endif


  200 continue

      return
      end
 

C*****************************************************
C        INPUT DATA
C*****************************************************
C     -------------------------------------------
C     EXACT SOLUTION
C     -------------------------------------------
      real*8 function exact11(x,y,x0,y0)
      common /domain/ xmax,ymax
      real*8 x,y,xmax,ymax,x0,y0
      exact11=-(x-x0-xmax)/xmax
      end
 