C       MULTISCALE FINITE ELEMENT METHOD           *
C       OVERSAMPLING                               *
C       BOUNDARY CONDITION: Dirichlet              *
C       TO SOLVE THE MATRIX PROBLEM, USE dmgd9v    *
C                                                  *
C***************************************************
      program main
      parameter (max_nm=1402193, ! nm for level 9
     +           max_nxf=1025,  ! nxf for level 9
     +           max_nyf=1025,  ! nyf for level 9
     +           max_nv=2048,
     +           max_nx=128,
     +           max_ny=128)

      real*8 ma(max_nm*9),mrhs(max_nm),a(max_nxf,max_nyf,9),
     +       vb(max_nm),ldu(3*max_nm),work(max_nxf*12),
     +       wa(max_nm),wb(max_nm),p(max_nm),rhs(max_nxf,max_nyf),
     +	     perm(-255:1280,-255:1280),
c    +       erroru(2,max_nxf,max_nyf),errorflux(2,max_nxf-1,max_nyf-1),
     +        b(2,3,max_nm)
c    +       v_1(max_nv,max_nv,2),v_2(max_nv,max_nv,2),
c    +       v_3(max_nv,max_nv,2)
      real*8 stiff1(3,3,1024,1024), ! the size of global meshes
     +       stiff2(3,3,1024,1024)  ! nxglobal x nyglobal
c     real*8 rhs1_elem(3,3,1024,1024),rhs2_elem(3,3,1024,1024)
	real*8 rhs1(3,3),rhs2(3,3)
      real*8 hx,hy,tol,resno,value,area,x,y,eu,eflux
      real*8 stf1(3,3),stf2(3,3),stf3(3,3),stf4(3,3),stf5(3,3),stf6(3,3)
      real*8 value1,value2,value3,value4,value5,value6
      real*8 coor,basis,exact,flux,basis_x,basis_y
      real*8 hxl,hyl,xl,yl,b1,b2,b3,local_basis_x,local_basis_y
      integer nx,ny,nxc,nyc,nxf,nyf,nm,levels,i,j,k,l,
     +        istart,iprep,maxit,ifail,index,kcoor,node,
     +        iout(6),n1,n2,n3,num,mil,mjl,nb,ntran,mmi,mmj
	real*8 xleft,yleft,xright,yright
	integer nxfine,nyfine
	real*8 p_ex(max_nm),p_ex_c(1050625),p_max,norml2,v1
         character*13 filename

c	 real*8 normal(1024,4)
c        real*8 eps,delta,r0,pi
c        real*8 xw(4),yw(4),q(4),p_wf(4),p_wf_ex(4)
c	 real*8 permx(4),permy(4),permxy,p_wf_eng(4)
c        real*8 xmin(4),ymin(4),xmax(4),ymax(4)
c        integer nx_local(4),ny_local(4),num_x,num_y,nx1,nx2,ny1,ny2
c        common /well/ xw,yw,q
c        common /local/ nxl,nyl,hxl,hyl
c        common /epsilon/eps

      common /param/ nx,ny,hx,hy

      data nxc,nyc,istart,iprep,maxit,tol,ifail
     +    /5,5,0,0,50,1.0d-8,110/
      data iout/0,0,0,0,0,0/

C.....PARAMETERS..............................
	xleft=0.d0
	yleft=0.d0
	xright=1.d0
	yright=1.d0

      open(1, file='input.dat',status='old')
      read(1,*) levelslocal,nxlocal,nxglobal,levelsglobal,ineps,
     +          mimax,mjmax
	read(1,*)
	read(1,*) xleft,yleft,xright,yright
c	read(1,*)
c	eps=1.d0/ineps

c...    well location and production
c.
c        read(1,*) iw     !total number of wells
c        do nw=1,iw
c	 read(1,*)
c        read(1,*) xw(nw),yw(nw),q(nw)
c        read(1,*) xmin(nw),ymin(nw),xmax(nw),ymax(nw)
c        read(1,*) nx_local(nw),ny_local(nw)
c	 read(1,*) delta          !radius of well
c        end do
	
      close(1)
        pi=dacos(-1.d0)

      levels=levelsglobal     ! multigrid levels
      nx=nxglobal        ! number of spaces in x direction
      ny=nx        ! number of spaces in y direction

      hx=1.0d0/nx
      hy=1.0d0/ny
      area=0.5d0*hx*hy   ! area of the element

C.....LOCAL PARAMETERS.........................

      nxl=nxlocal
      nyl=nxl
      hxl=hx/nxl
      hyl=hy/nyl

C.....MULTIGRID INFORMATION...................

      nxf=nxc
      nyf=nyc
      nm=nxf*nyf
      do k=2,levels
         nxf=2*nxf-1
         nyf=2*nyf-1
         nm=nm+nxf*nyf
      end do

      print*, 'nxf=',nxf,'nyf=',nyf,'nm=',nm

c*********************************************
c       input the permeability data
c*********************************************
c       nxstart=-255
c       nystart=-255
c       open(1,file='perms.dat')
c           read(1,*) nx1,ny1,ntot1
c           do i=nxstart,nx1+nxstart-1
c               read(1,*) (perm(i,j),j=nystart,ny1+nystart-1)
c           enddo
c       close(1)

c     do i=1,nx*nxl
c        do j=1,ny*nyl
c           perm(i,j)=(coef((i-1)*hxl,(j-1)*hyl)+coef((i-1)*hxl,j*hyl)
c    +                +coef(i*hxl,(j-1)*hyl)+coef(i*hxl,j*hyl))/4.0d0
c        end do
c     end do
   


C.....READ THE ELEMENT STIFFNESS MATRIX.........

      open(1,file='stf1',status='old')
      open(2,file='stf2',status='old')
c     open(3,file='rhs1')
c     open(4,file='rhs2')
      do 100 mmj=1,mjmax
	do 100 mmi=1,mimax
            read(1,*) ((stf1(i,j),j=1,3),i=1,3)
            read(2,*) ((stf2(i,j),j=1,3),i=1,3)
c	    read(3,*) ((rhs1(i,j),j=1,3),i=1,3)
c	    read(4,*) ((rhs2(i,j),j=1,3),i=1,3)
	    
      do mj=mmj,ny,mjmax
         do mi=mmi,nx,mimax
            do k=1,3
               do l=1,3
                  stiff1(k,l,mi,mj)=stf1(k,l)
                  stiff2(k,l,mi,mj)=stf2(k,l)
c 		  rhs1_elem(k,l,mi,mj)=rhs1(k,l)
c 		  rhs2_elem(k,l,mi,mj)=rhs2(k,l)
               end do
            end do
         end do
      end do
100	continue

      close(1)
      close(2)

C.....FORM THE MA MATRIX.....................

      do j=1,nyf
         do i=1,nxf
            do k=1,9
               a(i,j,k)=0.0d0
            end do
         end do
      end do

      ! boundary nodes: left and right
      do j=1,ny+1
         a(1,j,5)=1.0d0
         a(nx+1,j,5)=1.0d0
      end do

      ! Boundary nodes: top and bottom
      do i=1,nx+1
         a(i,1,5)=1.0d0
         a(i,ny+1,5)=1.0d0
      end do


      ! Boundary nodes: top and bottom
c     do i=2,nx
c        ! bottom boundary
c        call get_stiff(stf1,1,i-1,1,stiff1,stiff2)
c        call get_stiff(stf2,2,i,1,stiff1,stiff2)
c        call get_stiff(stf3,1,i,1,stiff1,stiff2)
c         print*, 'stf1=',((stf1(k,l),k=1,3),l=1,3)
c        if(i.eq.2) then
c           a(i,1,4)=0.0d0
c        else
c           a(i,1,4)=stf1(1,2)
c        end if
c        a(i,1,5)=stf1(2,2)+stf2(1,1)+stf3(1,1)
c        if(i.eq.nx) then
c           a(i,1,6)=0.0d0
c        else
c           a(i,1,6)=stf3(1,2)
c        end if
c        a(i,1,8)=stf1(2,3)+stf2(1,3)
c        if(i.eq.nx) then
c           a(i,1,9)=0.0d0
c        else
c           a(i,1,9)=stf2(1,2)+stf3(1,3)
c        end if

         ! top boundary
c        call get_stiff(stf1,2,i-1,ny,stiff1,stiff2)
c        call get_stiff(stf2,1,i-1,ny,stiff1,stiff2)
c        call get_stiff(stf3,2,i,ny,stiff1,stiff2)
c        if(i.eq.2) then
c           a(i,ny+1,1)=0.0d0
c        else
c           a(i,ny+1,1)=stf1(1,2)+stf2(1,3)
c        end if
c        a(i,ny+1,2)=stf2(2,3)+stf3(1,3)
c        if(i.eq.2) then
c           a(i,ny+1,4)=0.0d0
c        else
c           a(i,ny+1,4)=stf1(2,3)
c        end if
c        a(i,ny+1,5)=stf1(2,2)+stf2(3,3)+stf3(3,3)
c        if(i.eq.nx) then
c           a(i,ny+1,6)=0.0d0
c        else
c           a(i,ny+1,6)=stf3(2,3)
c        end if
c     end do

      ! Interior nodes
      do j=2,ny
         do i=2,nx
            call get_stiff(stf1,2,i-1,j-1,stiff1,stiff2)
            call get_stiff(stf2,1,i-1,j-1,stiff1,stiff2)
            call get_stiff(stf3,2,i,j-1,stiff1,stiff2)
            call get_stiff(stf4,1,i-1,j,stiff1,stiff2)
            call get_stiff(stf5,2,i,j,stiff1,stiff2)
            call get_stiff(stf6,1,i,j,stiff1,stiff2)
c           if(i.eq.2) then
c              a(i,j,1)=0.0d0
c           else
c              a(i,j,1)=stf1(1,2)+stf2(1,3)
c           end if
c           a(i,j,2)=stf2(2,3)+stf3(1,3)
c           if(i.eq.2) then
c              a(i,j,4)=0.0d0
c           else
c              a(i,j,4)=stf1(2,3)+stf4(1,2)
c           end if
c           a(i,j,5)=stf1(2,2)+stf2(3,3)+stf3(3,3)
c    +              +stf4(2,2)+stf5(1,1)+stf6(1,1)
c           if(i.eq.nx) then
c              a(i,j,6)=0.0d0
c           else
c              a(i,j,6)=stf3(2,3)+stf6(1,2)
c           end if
c           a(i,j,8)=stf4(2,3)+stf5(1,3)
c           if(i.eq.nx) then
c              a(i,j,9)=0.0d0
c           else
c              a(i,j,9)=stf5(1,2)+stf6(1,3)
c           end if
c       end do
c     end do

            if(i.eq.2.or.j.eq.2) then
               a(i,j,1)=0.0d0
            else
               a(i,j,1)=stf1(1,2)+stf2(1,3)
            end if
            if(j.eq.2) then
               a(i,j,2)=0.0d0
            else
               a(i,j,2)=stf2(2,3)+stf3(1,3)
            end if
            if(i.eq.2) then
               a(i,j,4)=0.0d0
            else
               a(i,j,4)=stf1(2,3)+stf4(1,2)
            end if
            a(i,j,5)=stf1(2,2)+stf2(3,3)+stf3(3,3)
     +              +stf4(2,2)+stf5(1,1)+stf6(1,1)
            if(i.eq.nx) then
               a(i,j,6)=0.0d0
            else
               a(i,j,6)=stf3(2,3)+stf6(1,2)
            end if
            if(j.eq.ny) then
               a(i,j,8)=0.0d0
            else
               a(i,j,8)=stf4(2,3)+stf5(1,3)
            end if
            if(i.eq.nx.or.j.eq.ny) then
               a(i,j,9)=0.0d0
            else
               a(i,j,9)=stf5(1,2)+stf6(1,3)
            end if
        end do
      end do



      ! change to the multigrid solver format
      do j=1,nyf  
         do i=1,nxf
            do k=1,9
               call assign_ma(ma,i,j,k,a(i,j,k),nxf,nyf)
            end do
         end do
      end do

C.....ASSEMBLE THE RHS...................................

      do j=1,nyf
         do i=1,nxf
            rhs(i,j)=0.0d0
         end do
      end do

      ! boundary nodes: left and right
      do j=1,ny+1
         rhs(1,j)=exact(0.0d0,(j-1)*hy)
         rhs(nx+1,j)=exact(nx*hx,(j-1)*hy)
      end do

      ! Boundary nodes: top and bottom
      do i=1,nx+1
         rhs(i,1)=exact((i-1)*hx,0.0d0)
         rhs(i,ny+1)=exact((i-1)*hx,ny*hy)
      end do


      ! Interior nodes
      do j=2,ny
         do i=2,nx
            call get_force(value1,2,2,i-1,j-1)
            call get_force(value2,3,1,i-1,j-1)
            call get_force(value3,3,2,i,j-1)
            call get_force(value4,2,1,i-1,j)
            call get_force(value5,1,2,i,j)
            call get_force(value6,1,1,i,j)
            rhs(i,j)=value1+value2+value3
     +              +value4+value5+value6
            if(i.eq.2.and.j.ne.2) then
               call get_stiff(stf1,2,1,j-1,stiff1,stiff2)
               call get_stiff(stf2,1,1,j-1,stiff1,stiff2)
               call get_stiff(stf4,1,1,j,stiff1,stiff2)
               rhs(i,j)=rhs(i,j)
     +            -(stf1(1,2)+stf2(1,3))*rhs(i-1,j-1)
     +            -(stf1(2,3)+stf4(1,2))*rhs(i-1,j)
            end if
            if(i.eq.nx.and.j.ne.ny) then
               call get_stiff(stf3,2,nx,j-1,stiff1,stiff2)
               call get_stiff(stf5,2,nx,j,stiff1,stiff2)
               call get_stiff(stf6,1,nx,j,stiff1,stiff2)
               rhs(i,j)=rhs(i,j)
     +                 -(stf3(2,3)+stf6(1,2))*rhs(i+1,j)
     +                 -(stf5(1,2)+stf6(1,3))*rhs(i+1,j+1)
            end if
            if(j.eq.2.and.i.ne.2) then
               call get_stiff(stf1,2,i-1,j-1,stiff1,stiff2)
               call get_stiff(stf2,1,i-1,j-1,stiff1,stiff2)
               call get_stiff(stf3,2,i,j-1,stiff1,stiff2)
               rhs(i,j)=rhs(i,j)
     +                 -(stf1(1,2)+stf2(1,3))*rhs(i-1,j-1)
     +                 -(stf2(2,3)+stf3(1,3))*rhs(i,j-1)
            end if
            if(j.eq.ny.and.i.ne.nx) then
               call get_stiff(stf4,1,i-1,j,stiff1,stiff2)
               call get_stiff(stf5,2,i,j,stiff1,stiff2)
               call get_stiff(stf6,1,i,j,stiff1,stiff2)
               rhs(i,j)=rhs(i,j)
     +                 -(stf4(2,3)+stf5(1,3))*rhs(i,j+1)
     +                 -(stf5(1,2)+stf6(1,3))*rhs(i+1,j+1)
            end if
            if(i.eq.2.and.j.eq.2) then
               call get_stiff(stf1,2,i-1,j-1,stiff1,stiff2)
               call get_stiff(stf2,1,i-1,j-1,stiff1,stiff2)
               call get_stiff(stf3,2,i,j-1,stiff1,stiff2)
               call get_stiff(stf4,1,i-1,j,stiff1,stiff2)
               rhs(i,j)=rhs(i,j)
     +                 -(stf1(1,2)+stf2(1,3))*rhs(i-1,j-1)
     +                 -(stf1(2,3)+stf4(1,2))*rhs(i-1,j)
     +                 -(stf2(2,3)+stf3(1,3))*rhs(i,j-1)
            end if
            if(i.eq.nx.and.j.eq.ny) then
               call get_stiff(stf3,2,i,j-1,stiff1,stiff2)
               call get_stiff(stf4,1,i-1,j,stiff1,stiff2)
               call get_stiff(stf5,2,i,j,stiff1,stiff2)
               call get_stiff(stf6,1,i,j,stiff1,stiff2)
               rhs(i,j)=rhs(i,j)
     +                 -(stf4(2,3)+stf5(1,3))*rhs(i,j+1)
     +                 -(stf5(1,2)+stf6(1,3))*rhs(i+1,j+1)
     +                 -(stf3(2,3)+stf6(1,2))*rhs(i+1,j)
            end if
         end do
      end do
*************************************



      ! change to the multigrid solver format
      do j=1,nyf  
         do i=1,nxf
            call assign_mrhs(mrhs,i,j,rhs(i,j),nxf,nyf)
         end do
      end do

      print*, 'go to mgd9v'
      call mgd9v(levels,nxc,nyc,nxf,nyf,nm,iout,istart,iprep,
     +     maxit,tol,mrhs,ma,p,vb,work,ldu,wa,wb,resno,ifail)
      print*,' ifail: ',ifail,' resno: ',resno
      print*, 'out of mgd9v'

c     print*, 'p=',(p(i),i=1,nxf*2)
c	output the result
	open(2,file='solution.dat')
	write(2,*) nxf,nyf,(p(i),i=1,nxf*nyf)
	close(2)

c	compare with the exact solution
c
 	open(1,file='exact_solution.dat',form='formatted')
  	read(1,*) nxfine,nyfine,(p_ex(i),i=1,nxfine*nyfine)
 	close(1)
c
c.	average on the fine grid to yiled coarse grid 'exact' solution
c
c       numx=(nxfine-1)/nx 
c       numy=(nyfine-1)/ny 
c       do j=1,ny 
c       do i=1,nx 
c          v1=0.d0
c          k0=(j-1)*numy*nxfine+(i-1)*numx+1
c          do jj=1,numy+1
c          do ii=1,numx+1
c               kk=k0+(jj-1)*nxfine+ii-1
c               v1=v1+p_ex(kk)
c          enddo
c          enddo
c          v1=v1/(numx+1)/(numy+1)
c          k=(j-1)*nx+i
c          p_ex_c(k)=v1
c       enddo
c       enddo


	
	eu=0.d0
	value=0.d0
        norml2=0.d0
        p_max=0.0d0
	nxfine=nxfine-1
	nyfine=nyfine-1
 	do j=2,ny
 	   do i=2,nx
 		n1=(j-1)*(nx+1)+i
 		n2=(j-1)*(nyfine/ny)*(nxfine+1)+(i-1)*(nxfine/nx)+1
 		eu=eu+(p(n1)-p_ex(n2))**2
 		if(value.lt.abs(p(n1)-p_ex(n2))) value=abs(p(n1)-p_ex(n2))
                norml2=norml2+p_ex(n2)**2
                if(p_max.lt.abs(p_ex(n2))) p_max=abs(p_ex(n2))
c		eu=eu+(p(n1)-p_ex_c(n1))**2
c		if(value.lt.abs(p(n1)-p_ex_c(n1))) value=abs(p(n1)-p_ex_c(n1))
c               norml2=norml2+p_ex_c(n1)**2
c               if(p_max.lt.abs(p_ex(n1))) p_max=abs(p_ex_c(n1))
 	   enddo
 	enddo
        norml2=dsqrt(norml2*hx*hy)  
 	eu=dsqrt(eu*hx*hy)
cccccccccccccccccccccccccc
c  This creates a file called error????.dat, where ???? is the partition
c  number on x-direction.
cccccccccccccccccccccccccc
        iter=nx
            ii1 = iter / 1000
            m1 = mod(ii1,10)
            ii2 = iter / 100
            m2 = mod(ii2,10)
            ii3 = iter / 10
            m3 = mod(ii3,10)
            m4 = mod(iter,10)

            filename = 'error'//char(m1+48)//char(48+m2)//char(48+m3)//
     $           char(48+m4)//'.dat'

 
        open(12,file=filename)
 	write(12,*) '  nx,  relative L^2-error,  relative  L^\infty-error'
 	write(12,*) nx,eu/norml2,value/p_max
 	close(12)
 	print*, 'L^2 error is  ', eu 
 	print*, 'L^\infty  error is  ',  value
        print*, 'l2-norm and L_inf norm of exact solution: ', norml2,
     &  p_max
      stop
      end

C     ------------------------------------------------
C     FUNCTION NTRAN
C     ------------------------------------------------
      integer function ntran(i)
      integer i
      real*8  a

      ntran=i

      return
      end

C     -------------------------------------------------
C     SUBROUTINE ASSIGN_MA
C     -------------------------------------------------
      subroutine assign_ma(ma,i,j,k,value,nxf,nyf)
      integer i,j,k,nxf,nyf
      real*8 ma(nxf,nyf,9),value

      ma(i,j,k)=value

      return
      end

C     -------------------------------------------------
C     SUBROUTINE ASSIGN_MRHS
C     -------------------------------------------------
      subroutine assign_mrhs(mrhs,i,j,value,nxf,nyf)
      integer i,j,nxf,nyf
      real*8 mrhs(nxf,nyf),value

      mrhs(i,j)=value

      return
      end

C****************************************************
C       ELEMENT INFORMATION
C****************************************************
C----------------------------------------------------
C     SUBROUTINE GET_STIFF
C----------------------------------------------------
      subroutine get_stiff(stf,index,i,j,stiff1,stiff2)
      real*8 stf(3,3),stiff1(3,3,1024,1024),stiff2(3,3,1024,1024)
      integer index,i,j,k,l
      common /param/ nx,ny,hx,hy

      if (index.eq.2) go to 100

      do 20 k=1,3
         do 10 l=1,3
         stf(k,l)=stiff1(k,l,i,j)
 10      continue
 20   continue
      go to 200

 100  continue

      do 60 k=1,3
         do 50 l=1,3
         stf(k,l)=stiff2(k,l,i,j)
 50      continue
 60   continue

 200  continue
      return
      end


C     -------------------------------------------------
C     SUBROUTINE GET_FORCE
C     --------------------------------------------------
      ! The integral of the force*basis(node) 
      ! over the element (i,j,index)
      subroutine get_force(value,node,index,i,j)
      common /param/nx,ny,hx,hy
      real*8 hx,hy,value,x,y,area
      real*8 force,coor,basis
      integer nx,ny,index,i,j,node,k,l

      area=0.5d0*hx*hy

      value=0.0d0
      do k=1,3
         x=coor(index,k,1,i,j)
         y=coor(index,k,2,i,j)
         value=value+force(x,y)*basis(index,node,x,y,i,j)/3.0d0 
      end do
      value=value*area

      return
      end

C     -------------------------------------------------
C     SUBROUTINE GET_NUM
C     --------------------------------------------------
      subroutine get_num(num,node,index,i,j)
      common /param/nx,ny,hx,hy
      real*8 hx,hy
      integer num,node,index,i,j,nx,ny

      if (index.eq.2) go to 100

      if     (node.eq.1) then
        num=(j-1)*(nx+1)+i
      elseif (node.eq.2) then
        num=(j-1)*(nx+1)+i+1
      elseif (node.eq.3) then
        num=j*(nx+1)+i+1
      else
        print*, 'problem here in get_num!'
      endif
      go to 200

  100 continue

      if     (node.eq.1) then
        num=(j-1)*(nx+1)+i
      elseif (node.eq.2) then
        num=j*(nx+1)+i+1
      elseif (node.eq.3) then
        num=j*(nx+1)+i
      else
        print*, 'problem here in get_num!'
      endif

  200 continue
      return
      end

C     -------------------------------------------------
C     SUBROUTINE GET_NUM_LOCAL
C     --------------------------------------------------
      subroutine get_num_local(num,node,index,i,j)
      common /local/nx,ny,hx,hy
      real*8 hx,hy
      integer num,node,index,i,j,nx,ny

      if (index.eq.2) go to 100

      if     (node.eq.1) then
        num=(j-1)*(nx+1)+i
      elseif (node.eq.2) then
        num=(j-1)*(nx+1)+i+1
      elseif (node.eq.3) then
        num=j*(nx+1)+i+1
      else
        print*, 'problem here in get_num!'
      endif
      go to 200

  100 continue

      if     (node.eq.1) then
        num=(j-1)*(nx+1)+i
      elseif (node.eq.2) then
        num=j*(nx+1)+i+1
      elseif (node.eq.3) then
        num=j*(nx+1)+i
      else
        print*, 'problem here in get_num!'
      endif

  200 continue
      return
      end

C     --------------------------------------------
C     FUNCTION COOR
C     --------------------------------------------
      real*8 function coor(index,node,kcoor,i,j)
      common /param/ nx,ny,hx,hy
      real*8 hx,hy
      integer nx,ny,index,node,kcoor,i,j

C     print*, 'this is coor'

      if (index.eq.2) go to 100
      
      if     (node.eq.1.and.kcoor.eq.1) then
        coor=i*hx
      elseif (node.eq.1.and.kcoor.eq.2) then
        coor=(j-1)*hy+0.5d0*hy
      elseif (node.eq.2.and.kcoor.eq.1) then
        coor=(i-1)*hx+0.5d0*hx
      elseif (node.eq.2.and.kcoor.eq.2) then
        coor=(j-1)*hy+0.5d0*hy
      elseif (node.eq.3.and.kcoor.eq.1) then
        coor=(i-1)*hx+0.5d0*hx
      elseif (node.eq.3.and.kcoor.eq.2) then
        coor=(j-1)*hy
      else
        print*, 'problem here in function coor!'
      endif
      go to 200

  100 continue 
      
      if     (node.eq.1.and.kcoor.eq.1) then
        coor=(i-1)*hx+0.5d0*hx
      elseif (node.eq.1.and.kcoor.eq.2) then
        coor=j*hy
      elseif (node.eq.2.and.kcoor.eq.1) then
        coor=(i-1)*hx
      elseif (node.eq.2.and.kcoor.eq.2) then
        coor=(j-1)*hy+0.5d0*hy
      elseif (node.eq.3.and.kcoor.eq.1) then
        coor=(i-1)*hx+0.5d0*hx
      elseif (node.eq.3.and.kcoor.eq.2) then
        coor=(j-1)*hy+0.5d0*hy
      else
        print*, 'problem here in function coor!'
      endif

  200 continue

      return
      end

C     ----------------------------------------------
C     FUNCTION BASIS
C     ----------------------------------------------
      real*8 function basis(index,node,x,y,i,j)
      common /param/ nx,ny,hx,hy
      real*8 hx,hy,x,y,x0,y0
      integer nx,ny,index,node,kcoor,i,j

      x0=(i-1)*hx
      y0=(j-1)*hy

      if (index.eq.2) go to 100

      if     (node.eq.1.) then
        basis=-(x-x0-hx)/hx
      elseif (node.eq.2) then
        basis=(x-x0)/hx-(y-y0)/hy
      elseif (node.eq.3) then
        basis=(y-y0)/hy
      else
        print*, 'problem here in function basis!'
      endif
      go to 200

  100 continue

      if     (node.eq.1.) then
        basis=-(y-y0-hy)/hy
      elseif (node.eq.2) then
        basis=(x-x0)/hx
      elseif (node.eq.3) then
        basis=(y-y0)/hy-(x-x0)/hx
      else
        print*, 'problem here in function basis!'
      endif


  200 continue

      return
      end

C     ----------------------------------------------
C     FUNCTION LOCAL_BASIS_X
C     ----------------------------------------------
      real*8 function local_basis_x(index,node)
      common /local/ nx,ny,hx,hy
      real*8 hx,hy
      integer nx,ny,index,node

      if (index.eq.2) go to 100

      if     (node.eq.1.) then
        local_basis_x=-1.0d0/hx
      elseif (node.eq.2) then
        local_basis_x=1.0d0/hx
      elseif (node.eq.3) then
        local_basis_x=0.0d0
      else
        print*, 'problem here in function local_basis!'
      endif
      go to 200

  100 continue

      if     (node.eq.1.) then
        local_basis_x=0.0d0
      elseif (node.eq.2) then
        local_basis_x=1.0d0/hx
      elseif (node.eq.3) then
        local_basis_x=-1.0d0/hx
      else
        print*, 'problem here in function local_basis!'
      endif

  200 continue

      return
      end

C     ----------------------------------------------
C     FUNCTION LOCAL_BASIS_Y
C     ----------------------------------------------
      real*8 function local_basis_y(index,node)
      common /local/ nx,ny,hx,hy
      real*8 hx,hy
      integer nx,ny,index,node

      if (index.eq.2) go to 100

      if     (node.eq.1.) then
        local_basis_y=-0.0d0
      elseif (node.eq.2) then
        local_basis_y=-1.0d0/hy
      elseif (node.eq.3) then
        local_basis_y=1.0d0/hy
      else
        print*, 'problem here in function local_basis!'
      endif
      go to 200

  100 continue

      if     (node.eq.1.) then
        local_basis_y=-1.0d0/hy
      elseif (node.eq.2) then
        local_basis_y=0.0d0
      elseif (node.eq.3) then
        local_basis_y=1.0d0/hy
      else
        print*, 'problem here in function local_basis!'
      endif

  200 continue

      return
      end


C*****************************************************
C        INPUT DATA
C*****************************************************

C     -------------------------------------------
C     SOURCE FUNCTION
C     -------------------------------------------
      real*8 function force(x,y)
      real*8 x,y     
      force=1.0d0
      end

C     -------------------------------------------
C     EXACT SOLUTION
C     -------------------------------------------
      real*8 function exact(x,y)
      real*8 x,y
      exact=.0d0
c     exact=1.0d0-x
      end

C     -------------------------------------------
C     EXACT FLUX
C     -------------------------------------------
      real*8 function flux(kcoor,x,y)
      integer kcoor
      real*8 x,y
      if     (kcoor.eq.1) then
         flux=0.0d0
      elseif (kcoor.eq.2) then
         flux=0.0d0
      else
         print*, 'problem here in function flux!'
      endif
 
      return
      end

      real*8 function coef(x,y)
      real*8 eps,pp,factor,x,y,pi
	common/epsilon/eps

      pp=1.8d0
      pi=dacos(-1.d0)
      coef=(2.d0+pp*dsin(2.d0*pi*x/eps))/(2.d0+pp*dsin(2.d0*pi*y/eps))
     +    +(2.d0+pp*dsin(2.d0*pi*y/eps))/(2.d0+pp*dcos(2.d0*pi*x/eps))

      
      return
      end
