C
C     ASSEMBLE THE MULTISCALE BASIS: OVER-SAMPLING
C
C***************************************************
      program main
c      parameter (max_nm=88399, ! nm for level 7
c     +           max_nx=128, max_ny=128)  
	include 'parameter.dat'
	parameter(max_nxyf=(max_nx+1)*(max_ny+1))
      real*8  p(2,3,max_nxyf),pp(max_nxyf),
     +        q(3,max_nxyf),a(3,3),b(3,3),perm(-255:1280,-255:1280)
      real*8 stf(3,3),stf1(3,3),stf2(3,3),hx,hy,
     +       xmax,ymax,area,value,eps
      integer levels,mx,nx,ny,nxyf,i,j,k,l,n1,n2,n3,index,
     +        levelsglobal,ineps,mimax,mjmax,
     +        nperm1,nperm2,nperm3,ntran

      common /param/ nx,ny,hx,hy
      common /domain/ xmax,ymax
      common /epsilon/eps
	common /perm/perm

C.....PARAMETERS..............................

      open(1,file='input.dat',status='old')
      read(1,*) levels,nx,mx,levelsglobal,ineps,mimax,mjmax
	read(1,*)
	read(1,*) xleft,yleft,xright,yright

      close(1)

	eps=1.d0/ineps
      ny=nx
      my=mx
	nxyf=(nx+1)*(ny+1)
      xmax=(xright-xleft)/mx
      ymax=(yright-yleft)/my

      hx=xmax/nx
      hy=ymax/ny
      area=0.5d0*hx*hy   ! area of the element

      print*, 'nx,mx,mimax,mjmax=',nx,mx,mimax,mjmax


      do i=1,3
        do j=1,3
          a(i,j)=-1.0d0
        end do
        a(i,i)=3.0d0
      end do
c*********************************************
c       input the permeability data
c*********************************************
        if (mx*nx .eq. 1024) then
                nxstart=-255
                nystart=-255
        else if (mx*nx .eq. 512 ) then
                 nxstart=-127
                 nystart=-127
        else if (mx*nx .eq. 256 ) then
                 nxstart=-63
                 nystart=-63
        endif

        open(1,file='perms.dat')
            read(1,*) nx1,ny1,ntot1
            do i=nxstart,nx1+nxstart-1
                read(1,*) (perm(i,j),j=nystart,ny1+nystart-1)
            enddo
        close(1)


 
      open(8,file='stf1',status='unknown')
      open(9,file='stf2',status='unknown')
	
C*******************************************************
      do 3000 mj=1,mjmax 
      do 3000 mi=1,mimax 
C*******************************************************
c        print*,'mi,mj=',mi,mj

C.....READ THE BASIS INFORMATION

c      read(1,*) nxyf, (p(1,1,i),i=1,nxyf)
c      read(2,*) nxyf, (p(1,2,i),i=1,nxyf)
c      read(3,*) nxyf, (p(1,3,i),i=1,nxyf) 

c	index = 1 elements

	call base11(pp,mi,mj)
	do i=1,nxyf
		p(1,1,i)=pp(i)
	enddo

	call base12(pp,mi,mj)
	do i=1,nxyf
		p(1,2,i)=pp(i)
	enddo
	 
	do i=1,nxyf
		p(1,3,i)=1.d0-p(1,1,i)-p(1,2,i)
	enddo

      do k=1,3
         do i=1,nxyf
            q(k,i)=0.0d0
            do l=1,3
               q(k,i)=q(k,i)+a(k,l)*p(1,l,i)
            end do
         end do
      end do
      do k=1,3
         do i=1,nxyf
            p(1,k,i)=q(k,i)
         end do
      end do
 
c	index = 2 elements 
c
 	call base21(pp,mi,mj)
	do i=1,nxyf
		p(2,1,i)=pp(i)
	enddo

	call base22(pp,mi,mj)
	do i=1,nxyf
		p(2,2,i)=pp(i)
	enddo
	 
	do i=1,nxyf
		p(2,3,i)=1.d0-p(2,1,i)-p(2,2,i)
	enddo


      do k=1,3
         do i=1,nxyf
            q(k,i)=0.0d0
            do l=1,3
               q(k,i)=q(k,i)+a(k,l)*p(2,l,i)
            end do
         end do
      end do
      do k=1,3
         do i=1,nxyf
            p(2,k,i)=q(k,i)
         end do
      end do
 
      do 100 k=1,3
         do 90 l=1,3
            stf1(k,l)=0.0d0
            do 80 i=1,nx
               do 70 j=1,i-1
                  do 60 index=1,2
                    value=perm(ntran((mi-1)*nx+i),ntran((mj-1)*ny+j)) 
                  call get_stiff(stf,index,i,j,value)
                  call get_num(n1,1,index,i,j)
                  call get_num(n2,2,index,i,j)
                  call get_num(n3,3,index,i,j)
                  stf1(k,l)=stf1(k,l)
     +                     +p(1,k,n1)*p(1,l,n1)*stf(1,1)
     +                     +p(1,k,n1)*p(1,l,n2)*stf(1,2)
     +                     +p(1,k,n1)*p(1,l,n3)*stf(1,3)
     +                     +p(1,k,n2)*p(1,l,n1)*stf(2,1)
     +                     +p(1,k,n2)*p(1,l,n2)*stf(2,2)
     +                     +p(1,k,n2)*p(1,l,n3)*stf(2,3)
     +                     +p(1,k,n3)*p(1,l,n1)*stf(3,1)
     +                     +p(1,k,n3)*p(1,l,n2)*stf(3,2)
     +                     +p(1,k,n3)*p(1,l,n3)*stf(3,3)
 60               continue
 70            continue
            index=1
                  value=perm(ntran((mi-1)*nx+i),ntran((mj-1)*ny+i))
            call get_stiff(stf,index,i,i,value)
            call get_num(n1,1,index,i,i)
            call get_num(n2,2,index,i,i)
            call get_num(n3,3,index,i,i)
            stf1(k,l)=stf1(k,l)
     +               +p(1,k,n1)*p(1,l,n1)*stf(1,1)
     +               +p(1,k,n1)*p(1,l,n2)*stf(1,2)
     +               +p(1,k,n1)*p(1,l,n3)*stf(1,3)
     +               +p(1,k,n2)*p(1,l,n1)*stf(2,1)
     +               +p(1,k,n2)*p(1,l,n2)*stf(2,2)
     +               +p(1,k,n2)*p(1,l,n3)*stf(2,3)
     +               +p(1,k,n3)*p(1,l,n1)*stf(3,1)
     +               +p(1,k,n3)*p(1,l,n2)*stf(3,2)
     +               +p(1,k,n3)*p(1,l,n3)*stf(3,3)
 80         continue
 90      continue
 100  continue

      do 200 k=1,3
         do 190 l=1,3
            stf2(k,l)=0.0d0
            do 180 i=1,nx
               do 170 j=i+1,ny
                  do 160 index=1,2
                     value=perm(ntran((mi-1)*nx+i),ntran((mj-1)*ny+j))
                  call get_stiff(stf,index,i,j,value)
                  call get_num(n1,1,index,i,j)
                  call get_num(n2,2,index,i,j)
                  call get_num(n3,3,index,i,j)
                  stf2(k,l)=stf2(k,l)
     +                     +p(2,k,n1)*p(2,l,n1)*stf(1,1)
     +                     +p(2,k,n1)*p(2,l,n2)*stf(1,2)
     +                     +p(2,k,n1)*p(2,l,n3)*stf(1,3)
     +                     +p(2,k,n2)*p(2,l,n1)*stf(2,1)
     +                     +p(2,k,n2)*p(2,l,n2)*stf(2,2)
     +                     +p(2,k,n2)*p(2,l,n3)*stf(2,3)
     +                     +p(2,k,n3)*p(2,l,n1)*stf(3,1)
     +                     +p(2,k,n3)*p(2,l,n2)*stf(3,2)
     +                     +p(2,k,n3)*p(2,l,n3)*stf(3,3)
 160               continue
 170            continue
            index=2
                     value=perm(ntran((mi-1)*nx+i),ntran((mj-1)*ny+i))
            call get_stiff(stf,index,i,i,value)
            call get_num(n1,1,index,i,i)
            call get_num(n2,2,index,i,i)
            call get_num(n3,3,index,i,i)
            stf2(k,l)=stf2(k,l)
     +               +p(2,k,n1)*p(2,l,n1)*stf(1,1)
     +               +p(2,k,n1)*p(2,l,n2)*stf(1,2)
     +               +p(2,k,n1)*p(2,l,n3)*stf(1,3)
     +               +p(2,k,n2)*p(2,l,n1)*stf(2,1)
     +               +p(2,k,n2)*p(2,l,n2)*stf(2,2)
     +               +p(2,k,n2)*p(2,l,n3)*stf(2,3)
     +               +p(2,k,n3)*p(2,l,n1)*stf(3,1)
     +               +p(2,k,n3)*p(2,l,n2)*stf(3,2)
     +               +p(2,k,n3)*p(2,l,n3)*stf(3,3)
 180        continue
 190     continue
 200  continue

      write(8,*) ((stf1(i,j),j=1,3),i=1,3)
      write(9,*) ((stf2(i,j),j=1,3),i=1,3)

 3000 continue

      close(8)
      close(9)

  
c      stop
      end

C     ------------------------------------------------
C     FUNCTION NTRAN
C     ------------------------------------------------
      integer function ntran(i)
      integer i  
      ntran=i 
      return
      end
c    -----------------------------------------------
c	function perm (i,j)
c    -----------------------------------------------
c	real*8 function perm(i,j)
c	integer i,j,nx,ny
c	real*8 hx,hy
c        common /param/ nx,ny,hx,hy
c           perm=(coef((i-1)*hx,(j-1)*hy)+coef((i-1)*hx,j*hy)
c    +                +coef(i*hx,(j-1)*hy)+coef(i*hx,j*hy))/4.0d0 
c	return 
c	end


C****************************************************
C       ELEMENT INFORMATION
C****************************************************
C     -----------------------------------------------
C     SUBROUTINE GET_STIFF
C     -----------------------------------------------
      subroutine get_stiff(stf,index,i,j,perm)
      common /param/nx,ny,hx,hy
      real*8 hx,hy,stf(3,3),area,bk1,bk2,bl1,bl2
      real*8 basis_x,basis_y,perm
      integer nx,ny,index,i,j,k,l

      area=0.5d0*hx*hy

      do k=1,3
         do l=1,3
            bk1=basis_x(index,k,i,j)
            bk2=basis_y(index,k,i,j)
            bl1=basis_x(index,l,i,j)
            bl2=basis_y(index,l,i,j)
            stf(k,l)=area*(bk1*bl1+bk2*bl2)*perm
         end do
      end do

      return
      end

C     -------------------------------------------------
C     SUBROUTINE GET_NUM
C     --------------------------------------------------
      subroutine get_num(num,node,index,i,j)
      common /param/nx,ny,hx,hy
      real*8 hx,hy
      integer num,node,index,i,j,nx,ny

      if (index.eq.2) go to 100

      if     (node.eq.1) then
        num=(j-1)*(nx+1)+i
      elseif (node.eq.2) then
        num=(j-1)*(nx+1)+i+1
      elseif (node.eq.3) then
        num=j*(nx+1)+i+1
      else
        print*, 'problem here in get_num!'
      endif
      go to 200

  100 continue

      if     (node.eq.1) then
        num=(j-1)*(nx+1)+i
      elseif (node.eq.2) then
        num=j*(nx+1)+i+1
      elseif (node.eq.3) then
        num=j*(nx+1)+i
      else
        print*, 'problem here in get_num!'
      endif

  200 continue
      return
      end

C     ----------------------------------------------
C     FUNCTION BASIS_X
C     ----------------------------------------------
      real*8 function basis_x(index,node,i,j)
      common /param/ nx,ny,hx,hy
      real*8 hx,hy
      integer nx,ny,index,node,kcoor,i,j

      if (index.eq.2) go to 100

      if     (node.eq.1.) then
        basis_x=-1.0d0/hx
      elseif (node.eq.2) then
        basis_x=1.0d0/hx
      elseif (node.eq.3) then
        basis_x=0.0d0
      else
        print*, 'problem here in function basis!'
      endif
      go to 200

  100 continue

      if     (node.eq.1.) then
        basis_x=0.0d0
      elseif (node.eq.2) then
        basis_x=1.0d0/hx
      elseif (node.eq.3) then
        basis_x=-1.0d0/hx
      else
        print*, 'problem here in function basis!'
      endif

  200 continue

      return
      end

C     ----------------------------------------------
C     FUNCTION BASIS_Y
C     ----------------------------------------------
      real*8 function basis_y(index,node,i,j)
      common /param/ nx,ny,hx,hy
      real*8 hx,hy
      integer nx,ny,index,node,kcoor,i,j

      if (index.eq.2) go to 100

      if     (node.eq.1.) then
        basis_y=-0.0d0
      elseif (node.eq.2) then
        basis_y=-1.0d0/hy
      elseif (node.eq.3) then
        basis_y=1.0d0/hy
      else
        print*, 'problem here in function basis!'
      endif
      go to 200

  100 continue

      if     (node.eq.1.) then
        basis_y=-1.0d0/hy
      elseif (node.eq.2) then
        basis_y=0.0d0
      elseif (node.eq.3) then
        basis_y=1.0d0/hy
      else
        print*, 'problem here in function basis!'
      endif

  200 continue

      return
      end 


      real*8 function coef(x,y)
      real*8 eps,pp,factor,x,y,pi
      common /epsilon/eps
      pp=1.8d0
      pi=3.1415926d0
      coef=(2.d0+pp*dsin(2.d0*pi*x/eps))/(2.d0+pp*dsin(2.d0*pi*y/eps))
     +    +(2.d0+pp*dsin(2.d0*pi*y/eps))/(2.d0+pp*dcos(2.d0*pi*x/eps))
c       coef=1.d0/(2.0d0+dcos(2.d0*pi*x/eps))
c    &           /(2.0d0+dcos(2.d0*pi*y/eps))
c     coef=(2.d0+dsin(2.d0*pi*x/eps))/(2.d0+dsin(2.d0*pi*y/eps))
c     coef=(2.d0+dsin(2.d0*pi*x/eps))*(2.d0+dcos(2.d0*pi*y/eps))
c    &  /(2.d0+dsin(2.d0*pi*x/eps)+dcos(2.d0*pi*x/eps))
c    &  /(2.d0+dcos(2.d0*pi*y/eps)-dsin(2.d0*pi*y/eps))

      return
      end
