C       MULTISCALE FINITE ELEMENT METHOD           *
C       OVERSAMPLING                               *
C       BOUNDARY CONDITION: Dirichlet              *
C       TO SOLVE THE MATRIX PROBLEM, USE dmgd9v    *
C                                                  *
C***************************************************
      program main
      parameter (max_nm=1402193, ! nm for level 9
     +           max_nxf=1025,  ! nxf for level 9
     +           max_nyf=1025,  ! nyf for level 9
     +           max_nv=2048)
c     +           max_nx=128,
c     +           max_ny=128)
c     +           max_nxL=128,
c     +           max_nyL=128)

	include 'parameter.dat'
      real*8 ma(max_nm*9),mrhs(max_nm),a(max_nxf,max_nyf,9),
     +       vb(max_nm),ldu(3*max_nm),work(max_nxf*12),
     +       wa(max_nm),wb(max_nm),p(max_nm),rhs(max_nxf,max_nyf),
     +	     perm(-255:1280,-255:1280),
c    +       erroru(2,max_nxf,max_nyf),errorflux(2,max_nxf-1,max_nyf-1),
     +        b(2,3,max_nm)
c    +       v_1(max_nv,max_nv,2),v_2(max_nv,max_nv,2),
c    +       v_3(max_nv,max_nv,2)
      real*8 stiff1(3,3,max_nx,max_ny), ! the size of global meshes
     +       stiff2(3,3,max_nx,max_ny)  ! nxglobal x nyglobal
c     real*8 rhs1_elem(3,3,max_nx,max_ny),rhs2_elem(3,3,max_nx,max_ny)
	real*8 rhs1(3,3),rhs2(3,3)
      real*8 hx,hy,tol,resno,value,area,x,y,eu,eflux
      real*8 stf1(3,3),stf2(3,3),stf3(3,3),stf4(3,3),stf5(3,3),stf6(3,3)
      real*8 value1,value2,value3,value4,value5,value6
      real*8 coor,basis,exact,flux,basis_x,basis_y
      real*8 hxl,hyl,xl,yl,b1,b2,b3,local_basis_x,local_basis_y
      integer nx,ny,nxc,nyc,nxf,nyf,nm,levels,i,j,k,l,
     +        istart,iprep,maxit,ifail,index,kcoor,node,
     +        iout(6),n1,n2,n3,num,mil,mjl,nb,ntran,mmi,mmj
	real*8 normal(1024,4)
        real*8 eps,delta,r0,pi
        real*8 xw(4),yw(4),q(4),p_wf(4),p_wf_ex(4)
	real*8 permx(4),permy(4),permxy,p_wf_eng(4)
        real*8 xmin(4),ymin(4),xmax(4),ymax(4)
	real*8 xleft,yleft,xright,yright
        integer nx_local(4),ny_local(4),num_x,num_y,nx1,nx2,ny1,ny2
        common /well/ xw,yw,q

        character*17 filename
        common /epsilon/eps

      common /local/ nxl,nyl,hxl,hyl
      common /param/ nx,ny,hx,hy
	common /domain/xleft,yleft,xright,yright
      data nxc,nyc,istart,iprep,maxit,tol,ifail
     +    /5,5,0,0,50,1.0d-8,110/
      data iout/0,0,0,0,0,0/

C.....PARAMETERS..............................
	xleft=0.d0
	yleft=0.d0
	xright=1.d0
	yright=1.d0

      open(1, file='input.dat',status='old')
      read(1,*) levelslocal,nxlocal,nxglobal,levelsglobal,ineps,
     +          mimax,mjmax
	read(1,*)
	read(1,*) xleft,yleft,xright,yright
	read(1,*)
	eps=1.d0/ineps

c...    well location and production
c.
        read(1,*) iw     !total number of wells
        do nw=1,iw
	read(1,*)
        read(1,*) xw(nw),yw(nw),q(nw)
        read(1,*) xmin(nw),ymin(nw),xmax(nw),ymax(nw)
        read(1,*) nx_local(nw),ny_local(nw)
	read(1,*) delta          !radius of well
        end do
	
      close(1)
        pi=dacos(-1.d0)

      levels=levelsglobal     ! multigrid levels
      nx=nxglobal        ! number of spaces in x direction
      ny=nx        ! number of spaces in y direction

      hx=(xright-xleft)/nx
      hy=(yright-yleft)/ny
      area=0.5d0*hx*hy   ! area of the element

C.....LOCAL PARAMETERS.........................

      nxl=nxlocal
      nyl=nxl
      hxl=hx/nxl
      hyl=hy/nyl

C.....MULTIGRID INFORMATION...................

      nxf=nxc
      nyf=nyc
      nm=nxf*nyf
      do k=2,levels
         nxf=2*nxf-1
         nyf=2*nyf-1
         nm=nm+nxf*nyf
      end do

      print*, 'nxf=',nxf,'nyf=',nyf,'nm=',nm

c*********************************************
c       input the permeability data
c*********************************************
c       nxstart=-255
c       nystart=-255
c       open(1,file='perms.dat')
c           read(1,*) nx1,ny1,ntot1
c           do i=nxstart,nx1+nxstart-1
c               read(1,*) (perm(i,j),j=nystart,ny1+nystart-1)
c           enddo
c       close(1)


C.....READ THE ELEMENT STIFFNESS MATRIX.........

      open(1,file='stf1',status='old')
      open(2,file='stf2',status='old')
c     open(3,file='rhs1')
c     open(4,file='rhs2')
      do 100 mmj=1,mjmax
	do 100 mmi=1,mimax
            read(1,*) ((stf1(i,j),j=1,3),i=1,3)
            read(2,*) ((stf2(i,j),j=1,3),i=1,3)
c	    read(3,*) ((rhs1(i,j),j=1,3),i=1,3)
c	    read(4,*) ((rhs2(i,j),j=1,3),i=1,3)
	    
      do mj=mmj,ny,mjmax
         do mi=mmi,nx,mimax
            do k=1,3
               do l=1,3
                  stiff1(k,l,mi,mj)=stf1(k,l)
                  stiff2(k,l,mi,mj)=stf2(k,l)
c 		  rhs1_elem(k,l,mi,mj)=rhs1(k,l)
c 		  rhs2_elem(k,l,mi,mj)=rhs2(k,l)
               end do
            end do
         end do
      end do
100	continue

      close(1)
      close(2)

C.....FORM THE MA MATRIX.....................

      do j=1,nyf
         do i=1,nxf
            do k=1,9
               a(i,j,k)=0.0d0
            end do
         end do
      end do

      ! boundary nodes: left and right
      do j=1,ny+1
         a(1,j,5)=1.0d0
         a(nx+1,j,5)=1.0d0
      end do

      ! Boundary nodes: top and bottom
      do i=1,nx+1
         a(i,1,5)=1.0d0
         a(i,ny+1,5)=1.0d0
      end do


      ! Boundary nodes: top and bottom
c     do i=2,nx
c        ! bottom boundary
c        call get_stiff(stf1,1,i-1,1,stiff1,stiff2)
c        call get_stiff(stf2,2,i,1,stiff1,stiff2)
c        call get_stiff(stf3,1,i,1,stiff1,stiff2)
c         print*, 'stf1=',((stf1(k,l),k=1,3),l=1,3)
c        if(i.eq.2) then
c           a(i,1,4)=0.0d0
c        else
c           a(i,1,4)=stf1(1,2)
c        end if
c        a(i,1,5)=stf1(2,2)+stf2(1,1)+stf3(1,1)
c        if(i.eq.nx) then
c           a(i,1,6)=0.0d0
c        else
c           a(i,1,6)=stf3(1,2)
c        end if
c        a(i,1,8)=stf1(2,3)+stf2(1,3)
c        if(i.eq.nx) then
c           a(i,1,9)=0.0d0
c        else
c           a(i,1,9)=stf2(1,2)+stf3(1,3)
c        end if

         ! top boundary
c        call get_stiff(stf1,2,i-1,ny,stiff1,stiff2)
c        call get_stiff(stf2,1,i-1,ny,stiff1,stiff2)
c        call get_stiff(stf3,2,i,ny,stiff1,stiff2)
c        if(i.eq.2) then
c           a(i,ny+1,1)=0.0d0
c        else
c           a(i,ny+1,1)=stf1(1,2)+stf2(1,3)
c        end if
c        a(i,ny+1,2)=stf2(2,3)+stf3(1,3)
c        if(i.eq.2) then
c           a(i,ny+1,4)=0.0d0
c        else
c           a(i,ny+1,4)=stf1(2,3)
c        end if
c        a(i,ny+1,5)=stf1(2,2)+stf2(3,3)+stf3(3,3)
c        if(i.eq.nx) then
c           a(i,ny+1,6)=0.0d0
c        else
c           a(i,ny+1,6)=stf3(2,3)
c        end if
c     end do

      ! Interior nodes
      do j=2,ny
         do i=2,nx
            call get_stiff(stf1,2,i-1,j-1,stiff1,stiff2)
            call get_stiff(stf2,1,i-1,j-1,stiff1,stiff2)
            call get_stiff(stf3,2,i,j-1,stiff1,stiff2)
            call get_stiff(stf4,1,i-1,j,stiff1,stiff2)
            call get_stiff(stf5,2,i,j,stiff1,stiff2)
            call get_stiff(stf6,1,i,j,stiff1,stiff2)
c           if(i.eq.2) then
c              a(i,j,1)=0.0d0
c           else
c              a(i,j,1)=stf1(1,2)+stf2(1,3)
c           end if
c           a(i,j,2)=stf2(2,3)+stf3(1,3)
c           if(i.eq.2) then
c              a(i,j,4)=0.0d0
c           else
c              a(i,j,4)=stf1(2,3)+stf4(1,2)
c           end if
c           a(i,j,5)=stf1(2,2)+stf2(3,3)+stf3(3,3)
c    +              +stf4(2,2)+stf5(1,1)+stf6(1,1)
c           if(i.eq.nx) then
c              a(i,j,6)=0.0d0
c           else
c              a(i,j,6)=stf3(2,3)+stf6(1,2)
c           end if
c           a(i,j,8)=stf4(2,3)+stf5(1,3)
c           if(i.eq.nx) then
c              a(i,j,9)=0.0d0
c           else
c              a(i,j,9)=stf5(1,2)+stf6(1,3)
c           end if
c       end do
c     end do

            if(i.eq.2.or.j.eq.2) then
               a(i,j,1)=0.0d0
            else
               a(i,j,1)=stf1(1,2)+stf2(1,3)
            end if
            if(j.eq.2) then
               a(i,j,2)=0.0d0
            else
               a(i,j,2)=stf2(2,3)+stf3(1,3)
            end if
            if(i.eq.2) then
               a(i,j,4)=0.0d0
            else
               a(i,j,4)=stf1(2,3)+stf4(1,2)
            end if
            a(i,j,5)=stf1(2,2)+stf2(3,3)+stf3(3,3)
     +              +stf4(2,2)+stf5(1,1)+stf6(1,1)
            if(i.eq.nx) then
               a(i,j,6)=0.0d0
            else
               a(i,j,6)=stf3(2,3)+stf6(1,2)
            end if
            if(j.eq.ny) then
               a(i,j,8)=0.0d0
            else
               a(i,j,8)=stf4(2,3)+stf5(1,3)
            end if
            if(i.eq.nx.or.j.eq.ny) then
               a(i,j,9)=0.0d0
            else
               a(i,j,9)=stf5(1,2)+stf6(1,3)
            end if
        end do
      end do



      ! change to the multigrid solver format
      do j=1,nyf  
         do i=1,nxf
            do k=1,9
               call assign_ma(ma,i,j,k,a(i,j,k),nxf,nyf)
            end do
         end do
      end do

C.....ASSEMBLE THE RHS...................................

      do j=1,nyf
         do i=1,nxf
            rhs(i,j)=0.0d0
         end do
      end do

      ! boundary nodes: left and right
      do j=1,ny+1
         rhs(1,j)=exact(xleft,yleft+(j-1)*hy)
         rhs(nx+1,j)=exact(xright,yleft+(j-1)*hy)
      end do

      ! Boundary nodes: top and bottom
      do i=1,nx+1
         rhs(i,1)=exact(xleft+(i-1)*hx,yleft)
         rhs(i,ny+1)=exact(xleft+(i-1)*hx,yright)
      end do


      ! Boundary nodes: top and bottom
c     do i=2,nx
c        ! bottom boundary
c        call get_force(value1,2,1,i-1,1)
c        call get_force(value2,1,2,i,1)
c        call get_force(value3,1,1,i,1)
c         print*, 'value1=',value1
c        rhs(i,1)=value1+value2+value3+hx*flux(2,(i-1)*hx,0.0d0)
c        if(i.eq.2) then
c           call get_stiff(stf1,1,1,1,stiff1,stiff2)
c           rhs(i,1)=rhs(i,1)-stf1(1,2)*rhs(i-1,1)
c        end if
c        if(i.eq.nx) then
c           call get_stiff(stf2,2,nx,1,stiff1,stiff2)
c           call get_stiff(stf3,1,nx,1,stiff1,stiff2)
c           rhs(i,1)=rhs(i,1)-stf3(1,2)*rhs(nx+1,1)
c    +                       -(stf2(1,2)+stf3(1,3))*rhs(nx+1,2)
c        end if

         ! top boundary
c        call get_force(value1,2,2,i-1,ny)
c        call get_force(value2,3,1,i-1,ny)
c        call get_force(value3,3,2,i,ny)
c        rhs(i,ny+1)=value1+value2+value3-hx*flux(2,(i-1)*hx,ny*hy)
c        if(i.eq.2) then
c           call get_stiff(stf1,2,1,ny,stiff1,stiff2)
c           call get_stiff(stf2,1,1,ny,stiff1,stiff2)
c           rhs(i,ny+1)=rhs(i,ny+1)
c    +             -(stf1(1,2)+stf2(1,3))*rhs(1,ny)
c    +             -stf1(2,3)*rhs(1,ny+1)
c        end if
c        if(i.eq.nx) then
c           call get_stiff(stf3,2,nx,ny,stiff1,stiff2)
c           rhs(i,ny+1)=rhs(i,ny+1)-stf3(2,3)*rhs(nx+1,ny+1)
c        end if
c     end do

      ! Interior nodes
        do 111  nw=1,iw
           filename='normal'//char(nw+48)//'.dat'
           open(9,file=filename,form='unformatted')

c           if (nw.eq.1) then
c              open(9,file='normal1.dat',form='unformatted')
c           else if (nw.eq.2) then
c              open(9,file='normal2.dat',form='unformatted')
c           else if (nw.eq.3) then
c              open(9,file='normal3.dat',form='unformatted')
c           else if (nw.eq.4) then
c              open(9,file='normal4.dat',form='unformatted')
c           else if (nw.eq.5) then
c              open(9,file='normal5.dat',form='unformatted')
c           else if (nw.eq.6) then
c              open(9,file='normal6.dat',form='unformatted')
c           endif

           read(9) p_wf(nw)
           read(9) nx_loc,(normal(m,1),m=1,nx_local(nw))
           read(9) ny_loc,(normal(m,2),m=1,ny_local(nw))
           read(9) nx_loc,(normal(m,3),m=1,nx_local(nw))
           read(9) ny_loc,(normal(m,4),m=1,ny_local(nw))
           close(9)

           nx1=idint((xmin(nw)-xleft+.001d0*hx)/hx)+1
           ny1=idint((ymin(nw)-yleft+.001d0*hy)/hy)+1
           nx2=idint((xmax(nw)-xleft+.001d0*hx)/hx)+1
           ny2=idint((ymax(nw)-yleft+.001d0*hy)/hy)+1
           num_x=nx_local(nw)/(nx2-nx1)
	   num_y=ny_local(nw)/(ny2-ny1)
c
c.         lower boundary of the small region
c.
           j=ny1
           do i=nx1,nx2-1
	    ! right edge-element
                do k=1,num_x
                  kk=(i-nx1)*num_x+k
                  rhs(i,j)=rhs(i,j)-q(nw)*normal(kk,1)*hx/num_x
     &                          *(1.d0-(k-.5d0)/num_x)
                end do
           end do
           do i=nx1+1,nx2
	    ! left edge-element
                do k=1,num_x
                   kk=(i-1-nx1)*num_x+k
                   rhs(i,j)=rhs(i,j)-q(nw)*normal(kk,1)*hx/num_x
     &                          *(k-.5d0)/num_x
                end do

           end do

!
c.         right boundary of the small region
c.
           i=nx2
           do j=ny1,ny2-1
	   ! upper edge-element
                do k=1,num_y
                  kk=(j-ny1)*num_y+k
                  rhs(i,j)=rhs(i,j)-q(nw)*normal(kk,2)*hy/num_y
     &                          *(1.d0-(k-.5d0)/num_y)
                end do
           end do
           do j=ny1+1,ny2
                do k=1,num_y
                   kk=(j-ny1-1)*num_y+k
                   rhs(i,j)=rhs(i,j)-q(nw)*normal(kk,2)*hy/num_y
     &                          *(k-.5d0)/num_y
                end do
           end do


c.         upper boundary of the small region
c.
           j=ny2
           do i=nx1,nx2-1
	   ! right edge-element
                do k=1,num_x
                  kk=(i-nx1)*num_x+k
                  rhs(i,j)=rhs(i,j)-q(nw)*normal(kk,3)*hx/num_x
     &                          *(1.d0-(k-.5d0)/num_x)
                end do
           end do
           do i=nx1+1,nx2
	   ! left edge-element
                do k=1,num_x
                   kk=(i-nx1-1)*num_x+k
                   rhs(i,j)=rhs(i,j)-q(nw)*normal(kk,3)*hx/num_x
     &                          *(k-.5d0)/num_x
                end do
           end do

c.         left boundary of the small region
c.
           i=nx1
           do j=ny1,ny2-1
                do k=1,num_y
                  kk=(j-ny1)*num_y+k
                  rhs(i,j)=rhs(i,j)-q(nw)*normal(kk,4)*hy/num_y
     &                          *(1.d0-(k-.5d0)/num_y)
                end do
           end do
           do j=ny1+1,ny2
                do k=1,num_y
                  kk=(j-ny1-1)*num_y+k
                  rhs(i,j)=rhs(i,j)-q(nw)*normal(kk,4)*hy/num_y
     &                          *(1.d0-(k-.5d0)/num_y)
                end do
           end do
 
111     continue
*************************************



      ! change to the multigrid solver format
      do j=1,nyf  
         do i=1,nxf
            call assign_mrhs(mrhs,i,j,rhs(i,j),nxf,nyf)
         end do
      end do

      print*, 'go to mgd9v'
      call mgd9v(levels,nxc,nyc,nxf,nyf,nm,iout,istart,iprep,
     +     maxit,tol,mrhs,ma,p,vb,work,ldu,wa,wb,resno,ifail)
      print*,' ifail: ',ifail,' resno: ',resno
      print*, 'out of mgd9v'

c     print*, 'p=',(p(i),i=1,nxf*2)
c	output the result
	open(2,file='solution.dat')
	write(2,*) nxf,nyf,(p(i),i=1,nxf*nyf)
	close(2)

c     do i=1,nx*nxl
c        do j=1,ny*nyl
c           perm(i,j)=(coef((i-1)*hxl,(j-1)*hyl)+coef((i-1)*hxl,j*hyl)
c    +                +coef(i*hxl,(j-1)*hyl)+coef(i*hxl,j*hyl))/4.0d0
c        end do
c     end do
   
c	compare with the exact solution
c
c	open(1,file='exact.dat',form='unformatted')
c 	read(1) num,(p_ex(i),i=1,num)
c	close(1)
	
	eu=0.d0
	value=0.d0
c	do j=2,ny
c	   do i=2,nx
c		n1=(j-1)*(nx+1)+i
c		n2=(j-1)*(512/ny)*513+(i-1)*(512/nx)+1
c		eu=eu+(p(n1)-p_ex(n2))**2
c		if(value.lt.abs(p(n1)-p_ex(n2))) value=abs(p(n1)-p_ex(n2))
c	   enddo
c	enddo
c	eu=dsqrt(eu*hx*hy)
cccccccccccccccccccccccccc
c  This creates a file called error????.dat, where ???? is the partition
c  number on x-direction.
cccccccccccccccccccccccccc
        iter=nx
            ii1 = iter / 1000
            m1 = mod(ii1,10)
            ii2 = iter / 100
            m2 = mod(ii2,10)
            ii3 = iter / 10
            m3 = mod(ii3,10)
            m4 = mod(iter,10)

            filename='error'//char(m1+48)//char(48+m2)//char(48+m3)//
     $           char(48+m4)//'.dat'

            open(10,file=filename)
        filename='error_eng'//char(m1+48)//char(48+m2)//char(48+m3)//
     $           char(48+m4)//'.dat'
            open(12,file=filename)
 
        write(10,*) ' well_no     nx     mx      bhp
     & error     relative error'
        write(12,*) ' well_no     nx     mx      bhp
     & error     relative error'

	num=nx*nxl
	if (num.eq.1024) then
	        open(11,file='eng1024.dat',status='old')
 	else if (num.eq.512) then
        	open(11,file='eng0512.dat',status='old')
 	else if (num.eq.256) then
        	open(11,file='eng0256.dat',status='old')
	else
	    print*, 'Fine grid partition .lt. 256  ?? '
		stop 'Check the partition number'
	endif
c	print*, 'fine grid nxfine : ', num

        do 99 nw=1,iw
        read(11,*)
        read(11,*) p_wf_ex(nw)
        read(11,*)
        read(11,*)
c     x=0.0d0
c     y=0.0d0
      i=idint((xw(nw)-xleft)/hx)+1
      j=idint((yw(nw)-yleft)/hy)+1
        x=xw(nw)
        y=yw(nw)
      index=1
      call get_num(n1,1,index,i,j)
      call get_num(n2,2,index,i,j)
      call get_num(n3,3,index,i,j)
      value=p(n1)*basis(index,1,x,y,i,j)
     +     +p(n2)*basis(index,2,x,y,i,j)
     +     +p(n3)*basis(index,3,x,y,i,j)
c
c       Peaceman's treatment
c
        permx(nw)=(stiff1(1,1,i,j)+stiff2(2,2,i,j))
        permy(nw)=(stiff1(3,3,i,j)+stiff2(1,1,i,j))
        permxy=-(stiff1(1,3,i,j)+stiff2(1,2,i,j))
        write(*,909) nw,permx(nw),permy(nw),permxy
909     format(1x,'Well No.',i3,' K_x : ',f10.6,'  K_y : ',f10.6,
     &          ' K_xy :',f10.6)
      r0=0.1403649d0*2.d0*dsqrt(dsqrt(permy(nw)/permx(nw))*hx*hx
     &          +dsqrt(permx(nw)/permy(nw))*hy*hy)
     &          /((permy(nw)/permx(nw))**.25+(permx(nw)/permy(nw))**.25)
      print*,'r0=',r0
        p_wf_eng(nw)=value-q(nw)/(2.d0*pi*dsqrt(permx(nw)*permy(nw)))
     &                          *dlog(delta/r0)



c       ------------------------------
c       Our well-treatment: to get the bottom-hole pressure
c       ------------------------------
c.
c
c.      --------------------------
c       step 2 : bottom-hole pressure
c       --------------------------
        p_wf(nw)=dabs(q(nw))*p_wf(nw)+value
        if (nw.eq.1) then
        write(*,*)
        write(*,*) 'bhp and error at No.1 by new method is :',
     &                  p_wf(nw),p_wf(nw)-p_wf_ex(nw)
        write(*,*) 'bhp and error at No.1 by Peaceman"s method is :',
     &                  p_wf_eng(nw),p_wf_eng(nw)-p_wf_ex(nw)
        write(*,*)
        else if(nw.eq.2) then
        write(*,*)
        write(*,*) 'bhp and error  at No.2 by new method is :',
     &                  p_wf(nw),p_wf(nw)-p_wf_ex(nw)
        write(*,*) 'bhp and error at No.2 by Peaceman"s method is :',
     &                  p_wf_eng(nw),p_wf_eng(nw)-p_wf_ex(nw)
        write(*,*)
c       write(10,*) 'bottom-hole pressure at No.2 by new method is :'
c       write(10,*)  p_wf(nw)
c       else if(nw.eq.3) then
c       write(*,*)
c       write(*,*) 'bottom-hole pressure at No.3 by new method is :',p_wf
c       write(*,*)
c       write(10,*) 'bottom-hole pressure at No.3 by new method is :',p_wf
c       else if(nw.eq.4) then
c       write(*,*)
c       write(*,*) 'bottom-hole pressure at No.4 by new method is :',p_wf
c       write(*,*)
c       write(10,*) 'bottom-hole pressure at No.4 by new method is :',p_wf
        endif

        write(10,12) nw, nx,nxl,p_wf(nw),p_wf(nw)-p_wf_ex(nw),
     &	(p_wf(nw)-p_wf_ex(nw))/p_wf_ex(nw)
        write(12,12) nw, nx,nxl,p_wf_eng(nw),p_wf_eng(nw)-p_wf_ex(nw),
     &	(p_wf_eng(nw)-p_wf_ex(nw))/p_wf_ex(nw)
99      continue
        close(10)
        close(12)
12      format(1x,3I5,f16.8,2e15.7)

c
c	write(1,*) '       nx,     L^2 - error,     L^\infty - error'
c	write(1,*) nx,eu,value
c	close(1)
c	print*, 'L^2 error is  ', eu 
c	print*, 'L^\infty  error is  ',  value
      stop
      end

C     ------------------------------------------------
C     FUNCTION NTRAN
C     ------------------------------------------------
      integer function ntran(i)
      integer i
      real*8  a

      ntran=i

      return
      end

C     -------------------------------------------------
C     SUBROUTINE ASSIGN_MA
C     -------------------------------------------------
      subroutine assign_ma(ma,i,j,k,value,nxf,nyf)
      integer i,j,k,nxf,nyf
      real*8 ma(nxf,nyf,9),value

      ma(i,j,k)=value

      return
      end

C     -------------------------------------------------
C     SUBROUTINE ASSIGN_MRHS
C     -------------------------------------------------
      subroutine assign_mrhs(mrhs,i,j,value,nxf,nyf)
      integer i,j,nxf,nyf
      real*8 mrhs(nxf,nyf),value

      mrhs(i,j)=value

      return
      end

C****************************************************
C       ELEMENT INFORMATION
C****************************************************
C----------------------------------------------------
C     SUBROUTINE GET_STIFF
C----------------------------------------------------
      subroutine get_stiff(stf,index,i,j,stiff1,stiff2)
	include 'parameter.dat'
      real*8 stiff1(3,3,max_nx,max_ny),stiff2(3,3,max_nx,max_ny)
	real*8 stf(3,3)
      integer index,i,j,k,l
      common /param/ nx,ny,hx,hy

      if (index.eq.2) go to 100

      do 20 k=1,3
         do 10 l=1,3
         stf(k,l)=stiff1(k,l,i,j)
 10      continue
 20   continue
      go to 200

 100  continue

      do 60 k=1,3
         do 50 l=1,3
         stf(k,l)=stiff2(k,l,i,j)
 50      continue
 60   continue

 200  continue
      return
      end


C     -------------------------------------------------
C     SUBROUTINE GET_FORCE
C     --------------------------------------------------
      ! The integral of the force*basis(node) 
      ! over the element (i,j,index)
      subroutine get_force(value,node,index,i,j)
      common /param/nx,ny,hx,hy
	include 'parameter.dat'
      real*8 hx,hy,value,x,y,area,rhs2_elem(3,3,max_nx,max_ny)
      real*8 force,coor,basis,rhs1_elem(3,3,max_nx,max_ny)
      integer nx,ny,index,i,j,node,k,l

      area=0.5d0*hx*hy


      value=0.0d0
      do k=1,3
         x=coor(index,k,1,i,j)
         y=coor(index,k,2,i,j)
         value=value+force(x,y)*basis(index,node,x,y,i,j)/3.0d0 
      end do
      value=value*area

      return
      end

C     -------------------------------------------------
C     SUBROUTINE GET_NUM
C     --------------------------------------------------
      subroutine get_num(num,node,index,i,j)
      common /param/nx,ny,hx,hy
      real*8 hx,hy
      integer num,node,index,i,j,nx,ny

      if (index.eq.2) go to 100

      if     (node.eq.1) then
        num=(j-1)*(nx+1)+i
      elseif (node.eq.2) then
        num=(j-1)*(nx+1)+i+1
      elseif (node.eq.3) then
        num=j*(nx+1)+i+1
      else
        print*, 'problem here in get_num!'
      endif
      go to 200

  100 continue

      if     (node.eq.1) then
        num=(j-1)*(nx+1)+i
      elseif (node.eq.2) then
        num=j*(nx+1)+i+1
      elseif (node.eq.3) then
        num=j*(nx+1)+i
      else
        print*, 'problem here in get_num!'
      endif

  200 continue
      return
      end
 
C     --------------------------------------------
C     FUNCTION COOR
C     --------------------------------------------
      real*8 function coor(index,node,kcoor,i,j)
      common /param/ nx,ny,hx,hy
      real*8 hx,hy
      integer nx,ny,index,node,kcoor,i,j
	real*8 xleft,yleft,xright,yright
	common /domain/xleft,yleft,xright,yright

C     print*, 'this is coor'

      if (index.eq.2) go to 100
      
      if     (node.eq.1.and.kcoor.eq.1) then
        coor=xleft+i*hx
      elseif (node.eq.1.and.kcoor.eq.2) then
        coor=yleft+(j-1)*hy+0.5d0*hy
      elseif (node.eq.2.and.kcoor.eq.1) then
        coor=xleft+(i-1)*hx+0.5d0*hx
      elseif (node.eq.2.and.kcoor.eq.2) then
        coor=yleft+(j-1)*hy+0.5d0*hy
      elseif (node.eq.3.and.kcoor.eq.1) then
        coor=xleft+(i-1)*hx+0.5d0*hx
      elseif (node.eq.3.and.kcoor.eq.2) then
        coor=yleft+(j-1)*hy
      else
        print*, 'problem here in function coor!'
      endif
      go to 200

  100 continue 
      
      if     (node.eq.1.and.kcoor.eq.1) then
        coor=xleft+(i-1)*hx+0.5d0*hx
      elseif (node.eq.1.and.kcoor.eq.2) then
        coor=yleft+j*hy
      elseif (node.eq.2.and.kcoor.eq.1) then
        coor=xleft+(i-1)*hx
      elseif (node.eq.2.and.kcoor.eq.2) then
        coor=yleft+(j-1)*hy+0.5d0*hy
      elseif (node.eq.3.and.kcoor.eq.1) then
        coor=xleft+(i-1)*hx+0.5d0*hx
      elseif (node.eq.3.and.kcoor.eq.2) then
        coor=yleft+(j-1)*hy+0.5d0*hy
      else
        print*, 'problem here in function coor!'
      endif

  200 continue

      return
      end

C     ----------------------------------------------
C     FUNCTION BASIS
C     ----------------------------------------------
      real*8 function basis(index,node,x,y,i,j)
      common /param/ nx,ny,hx,hy
      real*8 hx,hy,x,y,x0,y0
      integer nx,ny,index,node,kcoor,i,j
	real*8 xleft,yleft,xright,yright
	common /domain/xleft,yleft,xright,yright


      x0=xleft+(i-1)*hx
      y0=yleft+(j-1)*hy

      if (index.eq.2) go to 100

      if     (node.eq.1.) then
        basis=-(x-x0-hx)/hx
      elseif (node.eq.2) then
        basis=(x-x0)/hx-(y-y0)/hy
      elseif (node.eq.3) then
        basis=(y-y0)/hy
      else
        print*, 'problem here in function basis!'
      endif
      go to 200

  100 continue

      if     (node.eq.1.) then
        basis=-(y-y0-hy)/hy
      elseif (node.eq.2) then
        basis=(x-x0)/hx
      elseif (node.eq.3) then
        basis=(y-y0)/hy-(x-x0)/hx
      else
        print*, 'problem here in function basis!'
      endif


  200 continue

      return
      end

 
C*****************************************************
C        INPUT DATA
C*****************************************************

C     -------------------------------------------
C     SOURCE FUNCTION
C     -------------------------------------------
      real*8 function force(x,y)
      real*8 x,y     
      force=0.0d0
      end

C     -------------------------------------------
C     EXACT SOLUTION
C     -------------------------------------------
      real*8 function exact(x,y)
      real*8 x,y
      exact=.0d0
c     exact=1.0d0-x
      end

C     -------------------------------------------
C     EXACT FLUX
C     -------------------------------------------
      real*8 function flux(kcoor,x,y)
      integer kcoor
      real*8 x,y
      if     (kcoor.eq.1) then
         flux=0.0d0
      elseif (kcoor.eq.2) then
         flux=0.0d0
      else
         print*, 'problem here in function flux!'
      endif
 
      return
      end

      real*8 function coef(x,y)
      real*8 eps,pp,factor,x,y,pi
	common/epsilon/eps

      pp=1.8d0
      pi=dacos(-1.d0)
      coef=(2.d0+pp*dsin(2.d0*pi*x/eps))/(2.d0+pp*dsin(2.d0*pi*y/eps))
     +    +(2.d0+pp*dsin(2.d0*pi*y/eps))/(2.d0+pp*dcos(2.d0*pi*x/eps))

      
      return
      end
