	program stgenan
	implicit double precision(a-h,o-z)
c	dimension phi(70000),zz(70000),iave(70000),a(2,2),ai(2,2)
	dimension phi(6900000),zz(6900000),iave(6900000),a(2,2),ai(2,2)
	common /count/ ncount
	ncount=0
c
c  this program generates a random (normally distributed) phi field
c  with prescribed anisotropic correlation lengths and variance
c  using a moving ellipse averaging technique
c  ellipse lies at an angle theta relative to x axis
c
c  this program differs from stgen in that stgen forms an isotropic field while
c  stgenan forms an anisotropic phi field
c
	open(unit=21,file='stinan.dat')
c	open(unit=22,file='stout.dat')
c	open(unit=23,file='stdat.dat')
	open(unit=25,file='perms.dat')
c
c	open(unit=28,file='data.perm')
c
	read(21,*) nx1,ny1,xlmda1,xlmda2,theta,iseed
	read(21,*) phi0,sig0
	read(21,*) xlength,ylength
c
c  determine dx,dy,nx2,ny2
c
	theta=theta*3.141592654d0/180.d0
	dc=dcos(theta)
	ds=dsin(theta)
c	dx=1.d0/float(nx1)
c	dy=1.d0/float(ny1)
	dx=xlength/float(nx1)
	dy=ylength/float(ny1)
	xlmdmx=max(xlmda1,xlmda2)
	ndx=int(xlmdmx/dx)+1
	ndy=int(xlmdmx/dy)+1
	nx2=nx1+2*ndx
	ny2=ny1+2*ndy
	ntot1=nx1*ny1
	ntot2=nx2*ny2
	xlmd12=xlmda1**2
	xlmd22=xlmda2**2
c
	a(1,1)=xlmda1*dc*dc+xlmda2*ds*ds
	a(1,2)=(xlmda1-xlmda2)*dc*ds
	a(2,1)=(xlmda1-xlmda2)*dc*ds
	a(2,2)=xlmda1*ds*ds+xlmda2*dc*dc
c
	det=a(1,1)*a(2,2)-a(1,2)*a(2,1)
	ai(1,1)=a(2,2)/det
	ai(1,2)=-a(1,2)/det
	ai(2,1)=-a(2,1)/det
	ai(2,2)=a(1,1)/det
c
c  determine grid blocks to include in averaging
c
	do 2 i=1,ntot2
	iave(i)=0
2	continue
c
	i1=1
	i2=i1+ndx
	j1=1
	j2=j1+ndy
	iloc1=ny1*(i1-1)+j1
	iloc2=ny2*(i2-1)+j2
	icount=0
	ip=0
c
	do 5 ii=i2-ndx,i2+ndx
	dxi=dx*float(i2-ii)
	do 5 jj=j2-ndy,j2+ndy
	ip=ip+1
	dyi=dy*float(j2-jj)
	dxhv=ai(1,1)*dxi+ai(1,2)*dyi
	dyhv=ai(2,1)*dxi+ai(2,2)*dyi
	r2=dxhv**2+dyhv**2
	if(r2 .le. 1.d0) then
	iave(ip)=1
	icount=icount+1
	end if
5	continue
c
c	write(22,9997) ndx,ndy,icount
9997	format(1x,'ndx,ndy,icount=',3i5)
c
c  form random variables zz for nx2,ny2 grid
c
	do 10 kk=1,ntot2
	zz(kk)=ran2(iseed)
10	continue
c
c  perform moving ellipse average, loop on (nx1,ny1) grid
c
	do 100 i1=1,nx1
	i2=i1+ndx
	do 100 j1=1,ny1
	j2=j1+ndy
	iloc1=ny1*(i1-1)+j1
	iloc2=ny2*(i2-1)+j2
c
c  average over all zz values for which the grid block center falls within
c  ellipse centered in grid block (i2,j2)
c  these grid blocks will all fall within the rectangle defined by i2+-ndx, j2+-ndy
c
	ip=0
	ztot=0.d0
	do 50 ii=i2-ndx,i2+ndx
	do 50 jj=j2-ndy,j2+ndy
	ip=ip+1
	if(iave(ip) .eq. 1) then
	iiloc=ny2*(ii-1)+jj
	ztot=ztot+zz(iiloc)
	end if
50	continue
c
	phi(iloc1)=ztot/float(icount)
c
100	continue
c
c  compute average and variance of phi
c
	phia=0.d0
	phi2=0.d0
	do 120 kk=1,ntot1
	phia=phia+phi(kk)
120	continue
	phia=phia/float(ntot1)
	do 140 kk=1,ntot1
	phi2=phi2+(phia-phi(kk))**2
140	continue
	phi2=phi2/float(ntot1)
c
c	write(22,505) phia,phi2
505	format(1x,'ave and var of phi=',2e15.6)
c
	sigma=dsqrt(phi2)
	p1=phia-sigma
	p2=phia+sigma
	icount=0
	do 145 kk=1,ntot1
	if(phi(kk) .gt. p1 .and. phi(kk) .lt. p2) icount=icount+1
145	continue
	pc=float(icount)/float(ntot1)
c
c	write(22,511) pc
511	format(1x,'% within sigma of ave',e15.6)
c
c  rescale phi to recover prescribed average and standard deviation (phi0, sig0)
c
	sr=sig0/sigma
	do 180 kk=1,ntot1
	phi(kk)=phi0+(phi(kk)-phia)*sr
180	continue
c
c  compute average and sd of rescaled phi
c
	phia=0.d0
	phi2=0.d0
	do 220 kk=1,ntot1
	phia=phia+phi(kk)
220	continue
	phia=phia/float(ntot1)
	do 240 kk=1,ntot1
	phi2=phi2+(phia-phi(kk))**2
240	continue
	phi2=phi2/float(ntot1)
	snew=dsqrt(phi2)
c
c	write(22,515) phia,snew
515	format(/,1x,'ave and sd of rescaled phi=',2e15.6)
c
c	write(23,*) nx1,ny1,ntot1
c	write(23,*) (phi(kk),kk=1,ntot1)
c
c  form permeability field
c
	xkmin=1.d6
	xkmax=0.d0
	do 270 kk=1,ntot1
	phi(kk)=dexp(phi(kk))
	if(phi(kk) .gt. xkmax) xkmax=phi(kk)
	if(phi(kk) .lt. xkmin) xkmin=phi(kk)
270	continue
c
	ratio=xkmax/xkmin
c	write(22,519) xkmin,xkmax,ratio
519	format(1x,'xkmin,xkmax,ratio=',3e15.6)
c
c  compute averages
c
	ava=0.d0
	avg=0.d0
	avh=0.d0
	do 290 i=1,ntot1
	ava=ava+phi(i)
	avg=avg+dlog(phi(i))
	avh=avh+1.d0/phi(i)
290	continue
	ava=ava/float(ntot1)
	avg=dexp(avg/float(ntot1))
	avh=float(ntot1)/avh
	avath=dexp(0.5d0*sig0**2)
	avgth=1.d0
	avhth=dexp(-0.5d0*sig0**2)
c
c	write(22,521) ava,avath,avg,avgth,avh,avhth
521	format(//,1x,'averages',/,10x,'ava',8x,'avath',10x,'avg',8x,
     &     'avgth',10x,'avh',8x,'avhth',/,6e13.5)
c
	write(25,301) nx1,ny1,ntot1
c	write(28,311) nx1,ny1
c	write(25,303) (phi(kk),kk=1,ntot1)
c	write(28,303) (phi(kk),kk=1,ntot1)
	do 280 i=1,nx1
	iloc1=ny1*(i-1)+1
	iloc2=iloc1+ny1-1
	write(25,303) (phi(kk),kk=iloc1,iloc2)
280	continue
c
301	format(3i10)
303	format(6e13.5)
311	format(2i5)
c
	stop
	end

	FUNCTION RAN2(IDUM)
	IMPLICIT DOUBLE PRECISION(A-H,O-Z)
	common /count/ ncount
C
c	PARAMETER (M=714025,IA=1366,IC=150889)
	PARAMETER (M=2714025,IA=136,IC=550889)
	DIMENSION IR(97)
	DATA IFF /0/
c	ncount=ncount+1
C
C  PORTABLE RANDOM NUMBER GENERATOR FROM `NUMERICAL RECIPES,' P. 197
C
c	norder=97
	NORDER=97
	RM=1.D0/FLOAT(M)
	IF(IDUM .LT. 0 .OR. IFF .EQ. 0) THEN
	IFF=1
	IDUM=MOD(IC-IDUM,M)
	DO 11 J=1,NORDER
	IDUM=MOD(IA*IDUM+IC,M)
	IR(J)=IDUM
11	CONTINUE
	IDUM=MOD(IA*IDUM+IC,M)
	IY=IDUM
	END IF
 
c	IF(J .GT. NORDER .OR. J .LT. 1) THEN
c	WRITE(22,101)
c	WRITE(*,102) j,idum,ncount
c	STOP 'ran2'
c	END IF
c101	FORMAT(1X,'RAN2 ARRAY OUT OF BOUNDS')
c102	FORMAT(1X,'RAN2 ARRAY OUT OF BOUNDS', ' j=', i5,' idum= ',i8,
c    &		' ncount=',i8)

99	J=1+(NORDER*IY)/M
	IF (J.LT.1) THEN 
	   IY=MOD(IA*IY+IC,M)
	   GOTO 99
	ENDIF 
	IY=IR(J)
	RAN2=IY*RM
	IDUM=MOD(IA*IDUM+IC,M)
	IR(J)=IDUM
	RETURN
	END








